half4x4 Projection : Projection;

Texture ParticleTexture;
half ParticleSize;
half ViewportHeight;
half4x4 WorldViewProjection : WorldViewProjection;


sampler Sampler = sampler_state
{
	Texture = <ParticleTexture>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
};

struct PS_Input
{
    half4 Position : POSITION0;
    half2 TexCoord : TEXCOORD0;
    
    half4 Color    : COLOR0;
    half Size     : PSIZE0;
};

PS_Input VertexShaderFunction(PS_Input input)
{
    PS_Input output = (PS_Input)0;
    output.Position = mul(input.Position, WorldViewProjection);
    output.TexCoord = input.TexCoord;
    output.Color = input.Color;
    output.Size = ParticleSize * Projection._m11 / output.Position.w * ViewportHeight / 2;
    return output;
}

float4 PixelShaderFunction(PS_Input input) : COLOR0
{
    // TODO: add your pixel shader code here.
    half4 color = tex2D(Sampler, input.TexCoord.xy);
    color *= input.Color*2;
    return color;
}

technique ScaledPointSprite
{
    pass Pass1
    {
        VertexShader = compile vs_2_0 VertexShaderFunction();
        PixelShader = compile ps_2_0 PixelShaderFunction();
    }
}
