float mag;
bool hiRange;
sampler Sampler;

const float2 offsets[12] =
{
   -0.326212, -0.405805,
   -0.840144, -0.073580,
   -0.695914,  0.457137,
   -0.203345,  0.620716,
    0.962340, -0.194983,
    0.473434, -0.480026,
    0.519456,  0.767022,
    0.185461, -0.893124,
    0.507431,  0.064425,
    0.896420,  0.412458,
   -0.321940, -0.932615,
   -0.791559, -0.597705,
};
struct PSIn
{
	float2 TexCoord : TEXCOORD0;
};
float4 PixelShaderFunction(PSIn input) : COLOR0
{
	float4 sum = tex2D(Sampler,input.TexCoord);
	float4 tex;
	
	for (int i = 0; i < 12; i++)
	{
		tex = tex2D(Sampler,input.TexCoord + mag * offsets[i]);
		sum += tex;
	}
	
	
	sum /= 13;
	
	if (hiRange)
	{
		sum.r = (sum.r - 0.5) * 2.0;
		sum.g = (sum.g - 0.5) * 2.0;
		sum.b = (sum.b - 0.5) * 2.0;
	}
	sum.a = 1;
	return sum;
}

technique Bloom
{
    pass Pass1
    {
        PixelShader = compile ps_2_0 PixelShaderFunction();
    }
}
