float4x4 ViewProjection;
float4x4 View;
float4x4 Projection;
Texture Texture;

sampler Sampler = sampler_state
{
	Texture = <Texture>;
	MipFilter = POINT;
	MinFilter = POINT;
	MagFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
	AddressW = CLAMP;
};
struct VS_IN
{
    float4 Position : POSITION0;
    float4 Color    : COLOR0;
    float2 TexCoord : TEXCOORD0;
};

VS_IN VertexShaderFunction(VS_IN input)
{
    VS_IN output;
    ViewProjection = mul(View,Projection);
    output.Position = mul(input.Position, ViewProjection);
    output.Color = input.Color;
    output.TexCoord = input.TexCoord;
    return output;
}

float4 PixelShaderFunction(VS_IN input) : COLOR0
{
	float4 color = tex2D(Sampler,input.TexCoord);
	return color * input.Color;
}

technique SpriteRenderer
{
    pass Pass1
    {
        VertexShader = compile vs_2_0 VertexShaderFunction();
        PixelShader = compile ps_2_0 PixelShaderFunction();
    }
}
