using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;

namespace KLib
{
    /// <summary>
    /// Impliments a system to Position an object
    /// </summary>
    public interface IPositionable
    {
        /// <summary>
        /// Gets the Position of the Object
        /// </summary>
        Vector2 Position { get;}

        /// <summary>
        /// Move the Position of the Object by a specific amount
        /// </summary>
        /// <param name="amount">The amount to move the object</param>
        void Move(Vector2 amount);

        /// <summary>
        /// Moves the object to the specified position
        /// </summary>
        /// <param name="position">The position to move the object to</param>
        void MoveTo(Vector2 position);
    }
}
