using System;
using System.Collections.Generic;
using System.Text;

namespace KLib
{
    /// <summary>
    /// Impliments a system to Rotate an object
    /// </summary>
    public interface IRotatable
    {
        /// <summary>
        /// Gets the Rotation of the object
        /// </summary>
        float Rotation { get;}

        /// <summary>
        /// Rotates the object by a specific amount
        /// </summary>
        /// <param name="radians">The amount (in radians) to rotate</param>
        void Rotate(float radians);

        /// <summary>
        /// Rotate to a specific amount
        /// </summary>
        /// <param name="radians">The amount to rotate to</param>
        void RotateTo(float radians);
    }
}
