#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
#endregion

namespace KLib
{
    /// <summary>
    /// Queries the Game.Services collection and attempts to load a service of the requested type.
    /// If the Service is not found, the value is simply null, and throws no Exeptions. Use when the service is not required
    /// </summary>
    [AttributeUsage(AttributeTargets.Field | AttributeTargets.Property | AttributeTargets.Interface, AllowMultiple=false)]
    public class OptionalServiceAttribute : System.Attribute
    {
        #region Fields
        public Type serviceType;
        #endregion

        #region Properties
        public Type ServiceType
        {
            get { return serviceType; }
            set { serviceType = value; }
        }
        #endregion

        #region Initialization

        public OptionalServiceAttribute()
        {
            serviceType = null;
        }

        public OptionalServiceAttribute(Type serviceType)
        {
            this.serviceType = serviceType;
        }

        #endregion
    }
}
